include("chrome://jslib/content/io/dir.js");

var dir;
var directoryList;

function readDirectory(path) {
  dir = new Dir(path);
  directoryList = dir.readDir();

  var tree = document.getElementById('local');
  var treechildrenTemp = tree.getElementsByTagName("treechildren")[0];
  var treeitem;
  var treerow;
  var treecellFilename;
  var treecellFilesize;

  treechildren = treechildrenTemp.cloneNode(false);
  tree.removeChild(treechildrenTemp);
  tree.appendChild(treechildren);

  currentDirectory = document.getElementById('currentDirectory');
  currentDirectory.setAttribute('value', dir.path);

  for(x=0; x<directoryList.length; x++) {
    treeitem = document.createElement('treeitem');
    treerow = document.createElement('treerow');
    treecellFilename = document.createElement('treecell');
    treecellSize = document.createElement('treecell');
    treecellDateModified = document.createElement('treecell');
    treecellPermissons = document.createElement('treecell');

    treerow.setAttribute('directoryIndex', x);

    treecellFilename.setAttribute('label', directoryList[x].leaf);
    if(directoryList[x].isDir()) {
      //treecellFilename.setAttribute('properties', 'folder');
    }
    if(directoryList[x].isFile()) {
      //treecellFilename.setAttribute('properties', 'file');
    }

    treecellSize.setAttribute('label', directoryList[x].size);
    treecellDateModified.setAttribute('label', directoryList[x].dateModified);
    treecellPermissons.setAttribute('label', directoryList[x].permissons);

    treerow.appendChild(treecellFilename);
    treerow.appendChild(treecellSize);
    treerow.appendChild(treecellDateModified);
    treerow.appendChild(treecellPermissons);
    treeitem.appendChild(treerow);
    treechildren.appendChild(treeitem);
  }
}

/*
 * Tests if the mouse is clicked over an object in the list */
function getEventElementIndex(event, tree) {
  var row = new Object();
  tree.treeBoxObject.getCellAt( event.clientX, event.clientY, row, {}, {} );

  if( row.value!=-1 && row.value<tree.view.rowCount ) {
    return tree.getElementsByTagName("treechildren")[0].getElementsByTagName("treeitem")[row.value].getElementsByTagName("treerow")[0].getAttribute("directoryIndex");
  }
  else {
    return false;
  }
}

function fileMouseDown(event) {
  var tree = document.getElementById('local');
  //var treechildren = tree.getElementsByTagName("treechildren")[0];

  if(event.button == 2) {
    var directoryIndex = getEventElementIndex(event, tree);
    if(directoryIndex) {
      document.getElementById("upload_option").removeAttribute("disabled");

      filename = directoryList[directoryIndex].leaf;

      document.getElementById("upload_option").setAttribute("oncommand", "addFile2Queue('" + filename + "', 'upload');");
    }
    //If another menu?!
    else if( false ) {
    }
    else {
      //treechildren.setAttribute("context", "other-options");
      //tree.treeBoxObject.selection.clearSelection();
      // TODO HACK notifiers should be rewritten to integrate events and todos
      document.getElementById("upload_option").setAttribute("disabled", "true");
    }
  }
}

function fileDoubleClick(event){
  var tree = document.getElementById('local');
  if(event.button == 0) {
    var directoryIndex = getEventElementIndex(event, tree);
    if(directoryList[directoryIndex].isDir()) {
      readDirectory(directoryList[directoryIndex].path);
    }
  }
}
